﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace ConsoleInterface
{
    /// <summary>
    /// Наследник класса Persons
    /// Реализует методы интерфейса IEnumerator
    /// Предоставляет клиентам класса возможность
    /// собственной организации перебора объектов
    /// </summary>
    class People:Persons,IEnumerator
    {        
        int position = -1;
        public People() : base() { }
        public People(int size): base(size) { }
        public People(Person[] people) : base(people) { }

        /// <summary>
        /// передвигает курсор к следующему элементу в контейнере
        /// Возвращает true, если курсор установлен на элементе списка,
        /// false - в противном случае
        /// </summary>
        /// <returns></returns>
        public bool MoveNext()
        {
            if (position < size) position++;
            return (position < size);
        }
        /// <summary>
        /// Восстанавливает текущее положение курсора 
        /// в контейнере объектов 
        /// </summary>
        public void Reset()
        {
            position = -1;
        }
        /// <summary>
        /// Возвращает текущий объект, если курсор установлен 
        /// на элементе списка
        /// Выбрасывает исключение InvalidOperationException,
        /// когда курсор вне списка
        /// </summary>        
        public object Current
        {
            get
            {
                try
                {
                    return container[position];
                }

                catch (IndexOutOfRangeException)
                {
                    throw new InvalidOperationException();
                }
            }
            set
            {
                try
                {
                    container[position] = (Person)value;
                }

                catch (IndexOutOfRangeException)
                {
                    throw new InvalidOperationException();
                }
            }
        }

    }
}
