﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleInterface
{
    /// <summary>
    /// тестирующий класс
    /// </summary>
    class Testing
    {
        //поля класса        
        const string PAL = 
            "А роза упала на лапу Азора";
        static string[] CODE =
        {
            "абвгдежзиклмнопрстуфхцчшыъьэюя",        
            "abvgdejziklmnoprstyfhc461w'qux"
        };
        /// <summary>
        /// Тестирование класса SimpleText
        /// </summary>
        public void TestText()
        {
            Console.WriteLine("Работа с объектом класса SimpleText! ");
            SimpleText simpleText = new SimpleText(PAL);
            Console.WriteLine("Исходный текст : " + PAL); 
            string text;
            text = simpleText.Convert();
            Console.WriteLine("Преобразованный текст : " + text); 
            if(simpleText.IsPalindrom())
                Console.WriteLine("Это палиндром!");
            text = simpleText.Coding();
            Console.WriteLine("Шифрованный текст : " + text);            

            Console.WriteLine("Работа с объектом интерфейса IStrings! ");
            IStrings istrings;
            text = "Это простой текст!";
            Console.WriteLine("Исходный текст : " + text);
            simpleText = new SimpleText(text);
            istrings = (IStrings)simpleText;            
            text = istrings.Convert();
            Console.WriteLine("Преобразованный текст : " + text);
            text = istrings.Cipher(CODE);
            Console.WriteLine("Шифрованный текст : " + text);            
        }
        /// <summary>
        /// тестирование класса PrivateInterface
        /// </summary>
        public void TestTextPrivateInterface()
        {
            Console.WriteLine("Работа с объектом класса PrivateInterface! ");
            PrivateInterface privateInterface = new PrivateInterface(PAL);
            Console.WriteLine("Исходный текст : " + PAL);
            string text;
            text = privateInterface.ClassConvert();
            Console.WriteLine("Преобразованный текст : " + text);
            if (privateInterface.IsPalindrom())
                Console.WriteLine("Это палиндром!");
            text = privateInterface.Coding();
            Console.WriteLine("Шифрованный текст : " + text);

            Console.WriteLine("Работа с объектом интерфейса IStrings! ");
            IStrings istrings;
            text = "Это простой текст!";
            Console.WriteLine("Исходный текст : " + text);
            privateInterface = new PrivateInterface(text);
            istrings = (IStrings)privateInterface;
            text = istrings.Convert();
            Console.WriteLine("Преобразованный текст : " + text);
            text = istrings.Cipher(CODE);
            Console.WriteLine("Шифрованный текст : " + text);
        }
        public void TestTextTwoInterfaces()
        {
            Console.WriteLine("Работа с объектом класса TwoInterfaces! ");
            TwoInterfaces twoInterfaces = new TwoInterfaces(PAL);
            Console.WriteLine("Исходный текст : " + PAL);
            string text;
            text = twoInterfaces.ConvertOne();
            Console.WriteLine("Первое преобразование  : " + text);
            if (twoInterfaces.IsPalindrom())
                Console.WriteLine("Это палиндром!");
            text = twoInterfaces.ConvertTwo();
            Console.WriteLine("Второе преобразование  : " + text);
            text = twoInterfaces.Coding();
            Console.WriteLine("Шифрованный текст : " + text);
            
            text = "Это простой текст!";
            Console.WriteLine("Исходный текст : " + text);
            twoInterfaces = new TwoInterfaces(text);
            IStrings istrings;
            ITransform itransform;
            istrings = (IStrings)twoInterfaces;
            itransform = (ITransform)twoInterfaces;

            Console.WriteLine("Работа с объектом интерфейса IStrings!");
            text = istrings.Convert();
            Console.WriteLine("Преобразованный текст : " + text);
            text = istrings.Cipher(CODE);
            Console.WriteLine("Шифрованный текст : " + text);

            Console.WriteLine("Работа с объектом интерфейса ITransform!");            
            text = itransform.Convert();
            Console.WriteLine("Преобразованный текст : " + text);
            text = itransform.Cipher(CODE);
            Console.WriteLine("Шифрованный текст : " + text);
        }
        public void TestFields()
        {
            Console.WriteLine("Работа с объектом класса TwoFields!");
            TwoFields twofields = new TwoFields();
            Console.WriteLine("Имя: {0}, Возраст: {1}",
                twofields.Name, twofields.WhatAge());
            twofields.Name = "Captain Nemo";
            Console.WriteLine("Работа с интерфейсным объектом  IFields!");
            IFields ifields = (IFields)twofields;
            Console.WriteLine("Имя: {0}, Возраст: {1}",
                ifields.Name,ifields.Age);
        }
        public void TestCompare()
		{
			Person poet1 = new Person("Пушкин");
			Person poet2 = new Person("Лермонтов");
			Person poet3 = new Person("Пастернак");
			Person poet4 = new Person("Мандельштам");
			Person poet5 = new Person("Ахматова");
			Person poet6 = new Person("Цветаева");
			Console.WriteLine("{0} > {1} = {2}", poet1.Fam,
				poet2.Fam, (poet1 > poet2));
			Console.WriteLine("{0} >= {1} = {2}", poet3.Fam,
				poet4.Fam, (poet3 >= poet4));
			Console.WriteLine("{0} != {1} = {2}", poet5.Fam,
				poet6.Fam, (poet5 != poet6));
		}
        public void TestStandartClone()
        {
            Person mother = new Person("Петрова Анна");
            Person daughter = new Person("Петрова Ольга");
            Person son = new Person("Петров Игорь");
            mother[0] = daughter;
            mother[1] = son;
            Person mother_clone = mother.StandartClone();
            Console.WriteLine("Дети матери: {0}", mother.Fam);
            Console.WriteLine(mother[0].Fam);
            Console.WriteLine(mother[1].Fam);
            Console.WriteLine("Дети клона: {0}", mother_clone.Fam);
            Console.WriteLine(mother_clone[0].Fam);
            Console.WriteLine(mother_clone[1].Fam);
            Person mother_clone2 = (Person)mother.Clone();
            Console.WriteLine("Дети клона_2: {0}", mother_clone2.Fam);
            Console.WriteLine(mother_clone2[0].Fam);
            Console.WriteLine(mother_clone2[1].Fam);

        }
        public void TestEnumeration()
        {
            int size = 10;             
            Persons agents = new Persons(size);
            foreach (Person agent in agents)
                Console.WriteLine(agent.ToString());
            Console.WriteLine("Обратный порядок перечисления");
            foreach(Person agent in agents.ReverseIterator())
                Console.WriteLine(agent.ToString());
            Console.WriteLine("Перечисление языков программирования");
            foreach (ProgrammingLanguages lang in agents.LanguagesIterator())
                Console.WriteLine(lang.ToString());

        }
        public void TestPeople()
        {            
            People people = new People();            
            foreach (Person person in people)
                Console.WriteLine(person.ToString());
            
            Console.WriteLine("Работа клиента с коллекцией!");            
            try
            {
                Person person;
                person = new Person("James Bond", 44);
                people.MoveNext();
                people.Current = person;
                people.Reset();
                while (true)
                {
                    people.MoveNext();
                    person = (Person)people.Current;
                    Console.WriteLine(person.ToString());
                }
            }
            catch (InvalidOperationException)
            {
                people.Reset();
            }
        }
    }

}
